//
// Project : Jam
// File    : ArrayAccess.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class ArrayAccess extends BinaryOperator {

	ArrayAccess(Expr e1_, Expr e2_) {
		super(ARRAY_ACCESS, e1_, e2_) ;
	}

	public String toString() {
		return e1+"["+e2+"]" ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		e1 = e1.typeCheck(env, currentModule, cu) ;
		e2 = e2.typeCheck(env, currentModule, cu) ;
		Type t1 = e1.getType() ;
		if (t1 instanceof ArrayType) {
			type = ((ArrayType)t1).getBaseType() ;
			return this ;
		}
		throw new JamException("type \""+t1+"\" is not an array.") ;
	}

}

