//
// Project : Jam
// File    : ArrayCreationExpr.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;

abstract class ArrayCreationExpr extends Expr {

	protected Vector dimExprs ;
	protected int dimsOpt ;

	protected abstract String getTypename() ;

	ArrayCreationExpr(Vector dimExprs_, int dimsOpt_) {
		dimExprs = dimExprs_ ;
		dimsOpt = dimsOpt_ ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		ParsedObject.resolveExprs(dimExprs, cu) ;
	}

	public String toString() {
		StringBuffer buf = new StringBuffer("new ") ;
		buf.append(getTypename()) ;
		for(Enumeration e = dimExprs.elements() ; e.hasMoreElements() ;) {
			buf.append("[") ;
			buf.append(e.nextElement()) ;
			buf.append("]") ;
		}
		for(int a=0; a<dimsOpt; ++a) buf.append("[]") ;
		return buf.toString() ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		dimExprs = typeCheckVector(dimExprs, env, currentModule, cu) ;
		return this ;
	}

}

