//
// Project : Jam
// File    : ArrayType.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class ArrayType extends ReferenceType {

	private Type baseType ;

	public String toString() {
		return baseType+"[]" ;
	}

	ArrayType(Type baseType_) {
		baseType = baseType_ ;
	}

	protected boolean doubleDispatch(Type that) {
		return that.isSubtypeOf(this) ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		baseType.resolveNames(cu) ;
	}

	Type getBaseType() {
		return baseType ;
	}

	boolean isSubtypeOf(ClassType ct) {
		return ct.toString().equals("java.lang.Object") ;
	}

	boolean isSubtypeOf(ArrayType mt) {
		return baseType.isSubtypeOf(mt.baseType) ;
	}

}

