//
// Project : Jam
// File    : Assignment.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class Assignment extends BinaryOperator {
	
	Assignment(int op_, Expr e1_, Expr e2_) {
		super(op_, e1_, e2_) ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		e1 = e1.typeCheck(env, currentModule, cu) ;
		e2 = e2.typeCheck(env, currentModule, cu) ;
		if (e1 instanceof MixinFieldAccess) {
			MixinFieldAccess fa = (MixinFieldAccess)e1 ;
			return new MixinFieldAssignment(op, fa.getExpr(), fa.getIdentifier(), e2,
									fa.getType()) ;
		}
		type = e1.getType() ;
		return this ;
	}

}

