//
// Project : Jam
// File    : Block.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;
import invisible.jacc.parse.Token ;

class Block extends Statement {

	private Vector statements ;

	Block(Vector statements_) {
		super(null) ;
		statements = statements_ ;
	}

	void dump(TabPrintStream s) throws JamException {
		dump(s, false) ;
	}

	void dump(TabPrintStream s, boolean indent) throws JamException {
		s.println("{") ;
		if (indent) s.incLevel() ;
		dumpStatements(statements, s) ;
		if (indent) s.decLevel() ;
		s.println("}") ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		resolveStatements(statements, cu) ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		typeCheckStatements(statements, env, currentModule, cu) ;
	}

}

