//
// Project : Jam
// File    : BreakContinueStatement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

class BreakContinueStatement extends Statement {

	final static int BREAK		= 0 ;
	final static int CONTINUE	= 1 ;

	private final static String [] keywords = { "break", "continue" } ;

	private int statement ;
	private String identifier ; // may be null (if there's no identifier)

	BreakContinueStatement(int statement_, String identifier_, Token sourcePosition_) {
		super(sourcePosition_) ;
		statement = statement_ ;
		identifier = identifier_ ;
	}

	void dump(TabPrintStream s) {
		s.print(keywords[statement]+" ") ;
		if (identifier!=null) s.print(identifier+" ") ;
		s.println(";"+fileInfo(sourcePosition)) ;
	}

	void implResolveNames(CompilationUnit cu) {}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) {}

}
