//
// Project : Jam
// File    : CastExpression.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class CastExpression extends Expr {

	private Type destinationType ;
	private Expr expr ;

	CastExpression(Type destinationType_, Expr expr_) {
		destinationType = destinationType_ ;
		expr = expr_ ;
	}

	public String toString() {
		return "("+destinationType+")"+expr ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		destinationType.resolveNames(cu) ;
		expr.resolveNames(cu) ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		expr = expr.typeCheck(env, currentModule, cu) ;
		type = destinationType ;
		return this ;
	}

}

