//
// Project : Jam
// File    : CatchClause.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

class CatchClause extends ParsedObject {

	private FormalParameter parameter ;
	private Block block ;

	CatchClause(FormalParameter parameter_, Block block_, Token sourcePosition_) {
		super(sourcePosition_) ;
		parameter = parameter_ ;
		block = block_ ;
	}

	public void dump(TabPrintStream s) throws JamException {
		s.print("catch (") ;
		parameter.dump(s) ;
		s.println(")"+fileInfo(sourcePosition)) ;
		s.incLevel() ;
		block.dump(s) ;
		s.decLevel() ;
	}
	
	void implResolveNames(CompilationUnit cu) throws JamException {
		parameter.resolveNames(cu) ;
		block.resolveNames(cu) ;
	}

	void typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		env = env.copy() ;
		env.addAssociation(parameter.getIdentifier(), parameter.getType()) ;
		block.typeCheck(env, currentModule, cu) ;
	}

}
