//
// Project : Jam
// File    : ClassCreationExpression.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.Vector ;

class ClassCreationExpression extends Expr {

	private Name className ;
	private Vector arguments ;

	ClassCreationExpression(Name className_, Vector arguments_) {
		className = className_ ;
		arguments = arguments_ ;
	}

	public String toString() {
		return "new "+className+"("+toString(arguments)+")" ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		className = cu.getFullyQualifiedName(className) ;
		ParsedObject.resolveExprs(arguments, cu) ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		type = Type.getType(className.toString()) ;
		arguments = typeCheckVector(arguments, env, currentModule, cu) ;
		return this ;
	}

}
