//
// Project : Jam
// File    : ConditionalExpression.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class ConditionalExpression extends Expr {

	private Expr condition, e1, e2 ;

	ConditionalExpression(Expr condition_, Expr e1_, Expr e2_) {
		condition = condition_ ;
		e1 = e1_ ;
		e2 = e2_ ;
	}

	public String toString() {
		return condition+" ? "+e1+" : "+e2 ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		condition.resolveNames(cu) ;
		e1.resolveNames(cu) ;
		e2.resolveNames(cu) ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		e1 = e1.typeCheck(env, currentModule, cu) ;
		e2 = e2.typeCheck(env, currentModule, cu) ;
		type = e1.getType() ;
		return this ;
	}

}

