//
// Project : Jam
// File    : ConstructorInvocation.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.Vector ;
import invisible.jacc.parse.Token ;

class ConstructorInvocation extends Statement {

	final static int THIS	= 0 ;
	final static int SUPER	= 1 ;

	final int type ; // THIS or SUPER
	Vector args ;

	ConstructorInvocation(int type_, Vector args_, Token sourcePosition_) {
		super(sourcePosition_) ;
		if (type_!=THIS && type_!=SUPER)
			throw new RuntimeException("Internal compiler error (CI type="+type_+")") ;
		type = type_ ;
		args = args_ ;
	}

	public void dump(TabPrintStream s) {
		if (type==SUPER && args.size()==0) return ;
		s.print( type==THIS?"this(":"super(" ) ;
		s.println( Expr.toString(args)+") ;"+fileInfo(sourcePosition) ) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		resolveExprs(args, cu) ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		args = Expr.typeCheckVector(args, env, currentModule, cu) ;
	}

}

