//
// Project : Jam
// File    : Expr.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;

abstract class Expr {

	protected Type type ;

	public abstract String toString() ;

	abstract void resolveNames(CompilationUnit cu) throws JamException ;

	static String toString(Vector v) {
		StringBuffer s = new StringBuffer() ;
		boolean firstTime = true ;
		for(Enumeration e = v.elements() ; e.hasMoreElements() ; firstTime=false) {
			if (!firstTime) s.append(", ") ;
			s.append( (Expr)e.nextElement() ) ;
		}
		return s.toString() ;
	}

	Type getType() {
		return type ;
	}

	abstract Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException ;

	static Vector typeCheckVector(Vector v, Env env, ModuleType currentModule,
							CompilationUnit cu) throws JamException {

		if (v.size()==0) return v ; // avoid useless allocations
		Vector rv = new Vector() ;
		for(Enumeration e = v.elements() ; e.hasMoreElements() ;)
			rv.addElement( ((Expr)e.nextElement()).typeCheck(env, currentModule, cu) ) ;
		return rv ;
	}


}
