//
// Project : Jam
// File    : FormalParameter.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class FormalParameter extends Decl {

	private Type type ;
	private String identifier ;

	FormalParameter(Type t, VariableDeclaratorId varDeclId) {
		super(null) ;
		type = t.addDimensions(varDeclId.getDimensions()) ;
		identifier = varDeclId.getIdentifier() ;
	}

	Type getType() {
		return type ;
	}

	String getIdentifier() {
		return identifier ;
	}

	void dump(TabPrintStream s) {
		s.print(type+" "+identifier) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		type.resolveNames(cu) ;
	}

}
