//
// Project : Jam
// File    : ImportDeclaration.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

class ImportDeclaration extends Decl {

	private Name importedName ;
	private boolean onDemand ;

	ImportDeclaration(Name importedName_, boolean onDemand_, Token sourcePosition_) {
		super(sourcePosition_) ;
		importedName = importedName_ ;
		onDemand = onDemand_ ;
	}

	void dump(TabPrintStream s) {
		s.println("import "+importedName+(onDemand ? ".* ;":" ;")) ;
	}

	Name getPackageName() {
		return onDemand ? importedName.copy():null ;
	}

	Name match(String id) {
		if (onDemand) {
			Name fullName = importedName.copy().appendComponent(id) ;
			try	{
				Class.forName(fullName.toString()) ;
				return fullName ;
			} catch (ClassNotFoundException cnfe) {
				return null ;
			}
		}
		if (importedName.lastComponent().equals(id))
			return importedName.copy() ;
		return null ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {}

}
