//
// Project : Jam
// File    : InstanceOfExpr.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class InstanceOfExpr extends RelationalOperator {

	private Type t ;

	InstanceOfExpr(Expr e1_, Type t_) {
		super(INSTANCE_OF, e1_, null) ;
		t = t_ ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		e1.resolveNames(cu) ;
		t.resolveNames(cu) ;
	}

	public String toString() {
		return e1+" instanceof "+t ;
	}

}

