//
// Project : Jam
// File    : InterfaceDeclaration.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.Vector ;
import invisible.jacc.parse.Token ;

class InterfaceDeclaration extends TypeDeclaration {

	private Modifiers modifiers ;
	private Vector superInterfaces ;

	InterfaceDeclaration(Modifiers modifiers_, String identifier_, Vector superInterfaces_,
							Vector memberDecls_, Token sourcePosition_) {
		super(sourcePosition_, identifier_, memberDecls_) ;
		modifiers = modifiers_ ;
		superInterfaces = superInterfaces_ ;
	}

	void dump(TabPrintStream s) throws JamException {
		s.print(modifiers.toString()) ;
		s.print("interface "+identifier) ;
		if (superInterfaces.size()!=0) {
			s.print(" extends ") ;
			dumpNames(s, superInterfaces) ;
		}
		s.incLevel() ;
		s.println(" {\n") ;
		dumpDecls(s, memberDecls) ;
		s.decLevel() ;
		s.println("}\n") ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		superInterfaces = resolveNames(superInterfaces, cu) ;
		resolveDecls(memberDecls, cu) ;
	}

	private InterfaceType it ;

	void createModuleObject(CompilationUnit cu) throws JamException {
		super.createModuleObject(cu) ;
		it = new InterfaceType(fullName) ;
	}

	void extractModuleInformation(CompilationUnit cu) throws JamException {
		it.init(superInterfaces, fields(it), methods(it)) ;
	}

}
