//
// Project : Jam
// File    : LabeledStatement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class LabeledStatement extends Statement {

	private String label ;
	private Statement statement ;

	LabeledStatement(String label_, Statement statement_) {
		super(null) ;
		label = label_ ;
		statement = statement_ ;
	}

	void dump(TabPrintStream s) throws JamException {
		s.print(label+": ") ;
		statement.dump(s) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		statement.resolveNames(cu) ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		statement.typeCheck(env, currentModule, cu) ;
	}

}
