//
// Project : Jam
// File    : LocalVarDeclStatement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;
import invisible.jacc.parse.Token ;

class LocalVarDeclStatement extends Statement {

	private LocalVarDeclaration decl ;

	LocalVarDeclStatement(LocalVarDeclaration decl_, Token sourcePosition_) {
		super(sourcePosition_) ;
		decl = decl_ ;
	}

	void dump(TabPrintStream s) throws JamException {
		decl.dump(s) ;
		s.println(" ;"+fileInfo(sourcePosition)) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		decl.resolveNames(cu) ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		Type base = decl.getType() ;
		for(Enumeration e = decl.getDeclarators() ; e.hasMoreElements() ; ) {
			VariableDeclarator vd = (VariableDeclarator)e.nextElement() ;
			vd.typeCheck(env, currentModule, cu) ;
			VariableDeclaratorId vdId = vd.getDeclaratorId() ;
			env.addAssociation(vdId.getIdentifier(), base.addDimensions(vdId.getDimensions()));
		}
	}

}
