//
// Project : Jam
// File    : LocalVarDeclaration.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;

class LocalVarDeclaration extends Decl {

	private Type type ;
	private Vector declarators ;

	LocalVarDeclaration(Type type_, Vector declarators_) {
		super(null) ;
		type = type_ ;
		declarators = declarators_ ;
	}

	Type getType() {
		return type ;
	}

	Enumeration getDeclarators() {
		return declarators.elements() ;
	}

	void dump(TabPrintStream s) throws JamException {
		s.print(type.toString()+" ") ;
		dumpVD(s, declarators) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		type.resolveNames(cu) ;
		resolveVD(declarators, cu) ;
	}
 
}

