//
// Project : Jam
// File    : Method.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class Method extends MethodOrConstructor {

	private Type returnType ;
	private MethodDeclaration declaration ;

	Type getReturnType() {
		return returnType ;
	}

	MethodDeclaration getDeclaration() {
		return declaration ;
	}

	Method(ModuleType declaringModule_, Modifiers modifiers_, String identifier_, Type [] arguments_,
				Name [] exceptions_, Type returnType_, MethodDeclaration declaration_) {
		super(declaringModule_, modifiers_, identifier_, arguments_, exceptions_) ;
		returnType = returnType_ ;
		declaration = declaration_ ;
		if (DEBUG) {
			System.out.println("Method:") ;
			System.out.println("declaringModule="+declaringModule) ;
			System.out.println("modifiers="+modifiers) ;
			System.out.println("returnType="+returnType) ;
			System.out.println("identifier="+identifier) ;
			System.out.print("arguments=") ;
			for(int a=0; a<arguments.length; ++a)
				System.out.print(arguments[a]+" ") ;
			System.out.print("\nexceptions=") ;
			for(int a=0; a<exceptions.length; ++a)
				System.out.print(exceptions[a]+" ") ;
			System.out.println("\n") ;
		}
	}

	public String toString() { 
		StringBuffer sb = new StringBuffer( declaringModule+"."+identifier+"(" ) ;
		for(int a=0; a<arguments.length; ++a) {
			if (a!=0) sb.append(", ") ;
			sb.append(arguments[a]) ;
		}
		sb.append(")") ;
		return sb.toString() ;
	}

	boolean isMoreSpecific(Method other) {
		if ( arguments.length!=other.arguments.length )
			throw new RuntimeException("Internal compiler error in MoreSpecific") ;
		if ( !declaringModule.isSubtypeOf(other.declaringModule) )
			return false ;
		for(int a=0; a<arguments.length; ++a)
			if ( !arguments[a].isSubtypeOf(other.arguments[a]) )
				return false ;
		return true ;
	}

}

