//
// Project : Jam
// File    : MethodInvocation.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.Vector ;

abstract class MethodInvocation extends Expr {

	protected Vector arguments ;
	protected Type [] argumentTypes ;

	protected abstract String firstPart() ;

	MethodInvocation(Vector arguments_) {
		arguments = arguments_ ;
	}

	public String toString() {
		//System.out.println( "firstPart="+firstPart()+", class="+getClass()) ;
		return firstPart()+"("+toString(arguments)+")" ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		ParsedObject.resolveExprs(arguments, cu) ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		arguments = typeCheckVector(arguments, env, currentModule, cu) ;
		argumentTypes = new Type[arguments.size()] ;
		for(int a=0; a<argumentTypes.length; ++a)
			argumentTypes[a] = ((Expr)arguments.elementAt(a)).getType() ;
		return this ;
	}

}

