//
// Project : Jam
// File    : MixinUnaryOperator.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class MixinUnaryOperator extends UnaryOperator {

	private String field ;

	MixinUnaryOperator(int op_, boolean isPrefixed_, Expr expr_, String field_) {
		super(op_, isPrefixed_, expr_) ;
		field = field_ ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		return this ;
	}

	public String toString() {
		StringBuffer method = new StringBuffer(MixinDeclaration.mangled(expr.getType().toString())) ;
		method.append("_") ;
		method.append(isPrefixed ? "$prefix_" : "$postfix_") ;
		method.append(op==INCREMENT ? "increment$_" : "decrement$_") ;
		method.append(field) ;
		method.append("()") ;
		return expr+"."+method.toString() ;
	}

}

