//
// Project : Jam
// File    : Name.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.Vector ;

class Name implements Cloneable {

	private String fullName = "" ;

	Name() {}

	public boolean equals(Object o) {
		if (o instanceof Name)
			return fullName.equals( ((Name)o).fullName ) ;
		throw new RuntimeException("Compiler internal error in Name.equals; class is "+o.getClass()) ;
	}

	public int hashCode() {
		return fullName.hashCode() ;
	}

	Name copy() {
		try	{
			return (Name)clone() ;
		} catch (CloneNotSupportedException cantHappen) {}
		throw new RuntimeException("Universe internal error") ;
	}

	Name(String identifier) {
		appendComponent(identifier) ;
	}

	Name appendComponent(String component) {
		if (fullName.length()==0)
			fullName = component ;
		else	fullName = fullName+"."+component ; 
		return this ;
	}

	String lastComponent() {
		return fullName.substring(fullName.lastIndexOf('.')+1) ;
	}

	Name firstPart() {
		int i = fullName.lastIndexOf('.') ;
		return i==-1 ? null : new Name(fullName.substring(0, i)) ;
	}

	public String toString() {
		return fullName ;
	}

	boolean isSimpleName() {
		return fullName.indexOf('.')==-1 ;
	}

}
