//
// Project : Jam
// File    : NameMethodInvocation.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;

class NameMethodInvocation extends MethodInvocation {

	private Name name ;
	private Expr leftExpression ;

	NameMethodInvocation(Name name_, Vector arguments_) {
		super(arguments_) ;
		name = name_ ;
	}

	protected String firstPart() {
		//System.out.println("name="+name+", expr="+leftExpression) ;
		return leftExpression!=null ? leftExpression.toString()+"."+name.lastComponent() : name.toString() ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		super.typeCheck(env, currentModule, cu) ;
		String methodName = name.lastComponent() ;
		ModuleType module = currentModule ;
		if (!name.isSimpleName()) {
			Name firstPart = name.firstPart() ;
			leftExpression = NameExpr.typeOf(name.firstPart(), env, currentModule, cu) ;
			Type t = leftExpression.getType() ;
			if (! (t instanceof ModuleType) )
				throw new JamException("type \""+t+"\" doesn't have any methods.") ;
			module = (ModuleType)t ;
		}
		Method m = module.getMostSpecificMethod(methodName, argumentTypes, currentModule) ;
		type = m.getReturnType() ;
		return this ;
	}

}


