//
// Project : Jam
// File    : NilType.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class NilType extends Type {

	private NilType() {}

	protected boolean doubleDispatch(Type that) {
		return that.isSubtypeOf(this) ;
	}

	final static NilType instance = new NilType() ;

	public String toString() { return "nil [internal-use-only!]" ; }

	void resolveNames(CompilationUnit cu) throws JamException {}

	boolean isSubtypeOf(ClassType ct) { return true ; }
	boolean isSubtypeOf(InterfaceType it) { return true ; }
	boolean isSubtypeOf(MixinType mt) { return true ; }
	boolean isSubtypeOf(ArrayType mt) { return true ; }
	boolean isSubtypeOf(NilType nt) { return true ; }
}

