//
// Project : Jam
// File    : PrimaryMethodInvocation.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.Vector ;

class PrimaryMethodInvocation extends MethodInvocation {

	private Expr primary ;
	private String identifier ;

	PrimaryMethodInvocation(Expr primary_, String identifier_, Vector arguments_) {
		super(arguments_) ; 
		primary = primary_ ;
		identifier = identifier_ ;
	}

	protected String firstPart() {
		return primary+"."+identifier ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		super.resolveNames(cu) ;
		primary.resolveNames(cu) ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		super.typeCheck(env, currentModule, cu) ;
		primary = primary.typeCheck(env, currentModule, cu) ;
		Type t = primary.getType() ;
		if (!(t instanceof ModuleType))
			throw new JamException("type \""+t+"\" doesn't have any methods.") ;
		Method m = ((ModuleType)t).getMostSpecificMethod(identifier, argumentTypes, currentModule) ;
		type = m.getReturnType() ;
		return this ;
	}

}


