//
// Project : Jam
// File    : PrimitiveArrayCreation.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;

class PrimitiveArrayCreation extends ArrayCreationExpr {

	private PrimitiveType type ;

	PrimitiveArrayCreation(PrimitiveType type_, Vector dimExprs_, int dimsOpt_) {
		super(dimExprs_, dimsOpt_) ;
		type = type_ ;
	}

	protected String getTypename() {
		return type.toString() ;
	}
	
	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		super.typeCheck(env, currentModule, cu) ;
		Type t = type ;
		int d = dimExprs.size()+dimsOpt ;
		for(int a=0; a<d; ++a) t = new ArrayType(t) ;
		((Expr)this).type = t ;
		return this ;
	}

}
