//
// Project : Jam
// File    : ReferenceArrayCreation.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.* ;

class ReferenceArrayCreation extends ArrayCreationExpr {

	private Name type ;

	ReferenceArrayCreation(Name type_, Vector dimExprs_, int dimsOpt_) {
		super(dimExprs_, dimsOpt_) ;
		type = type_ ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		super.resolveNames(cu) ;
		type = cu.getFullyQualifiedName(type) ;
	}

	protected String getTypename() {
		return type.toString() ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		super.typeCheck(env, currentModule, cu) ;
		Type t = Type.getType(type.toString()) ;
		int d = dimExprs.size()+dimsOpt ;
		for(int a=0; a<d; ++a) t = new ArrayType(t) ;
		((Expr)this).type = t ;
		return this ;
	}

}
