//
// Project : Jam
// File    : ReturnStatement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

class ReturnStatement extends Statement {

	private Expr expr ; // may be null (in case of "return ;")

	ReturnStatement(Expr expr_, Token sourcePosition_) {
		super(sourcePosition_) ;
		expr = expr_ ;
	}

	void dump(TabPrintStream s) {
		if (expr==null)
			s.println("return ;"+fileInfo(sourcePosition)) ;
		else	s.println("return "+expr+" ;"+fileInfo(sourcePosition)) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		if (expr!=null)
			expr.resolveNames(cu) ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		if (expr!=null) {
			expr = expr.typeCheck(env, currentModule, cu) ;
			//System.out.println("(ReturnStatement) type="+expr.getType()) ;
		}
	}

}

