//
// Project : Jam
// File    : Statement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

abstract class Statement extends ParsedObject {

	Statement(Token sourcePosition_) {
		super(sourcePosition_) ;
	}

	abstract void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException;

	final void typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		try	{
			implTypeCheck(env, currentModule, cu) ;
		} catch (JamException e) {
			e.setToken(sourcePosition) ;
			throw e ;
		}
	}

}

