//
// Project : Jam
// File    : StaticFieldAccess.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class StaticFieldAccess extends FieldAccess {

	private ModuleType moduleType ;

	StaticFieldAccess(ModuleType moduleType_, String identifier_) {
		super(identifier_) ;
		moduleType = moduleType_ ;
	}

	public String toString() {
		return moduleType.getModuleName()+"."+identifier ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		Field f = moduleType.getField(identifier) ;
		if (f!=null) {
			if ( !f.getModifiers().isSet(Modifiers.STATIC) ) 
				throw new JamException("\""+identifier+"\" isn't a static field.") ;
			type = f.getType() ;
			return this ;
		}
		throw new JamException("\""+moduleType+"\" hasn't a field named \""+identifier+"\".") ;
	}

}

