//
// Project : Jam
// File    : StaticInitializer.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class StaticInitializer extends MemberDeclaration {

	private Block block ;

	StaticInitializer(Block block_) {
		super(null) ;
		block = block_ ;
	}

	void dump(TabPrintStream s) throws JamException {
		s.print("static ") ;
		block.dump(s, true) ;
	}

	void mixinDump(TabPrintStream s) throws JamException {
		dump(s) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		block.typeCheck(env, currentModule, cu) ;
	}

}
