//
// Project : Jam
// File    : SuperFieldAccess.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class SuperFieldAccess extends FieldAccess {

	SuperFieldAccess(String identifier_) {
		super(identifier_) ;
	}

	public String toString() {
		return "super."+identifier ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		Field f = currentModule.getSuperField(identifier) ;
		if (f!=null) {
			type = f.getType() ;
			return this ;
		}
		throw new JamException("\""+currentModule+"\" parent hasn't a field named \""+identifier+"\".") ;
	}
}

