//
// Project : Jam
// File    : SuperMethodInvocation.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import java.util.Vector ;

class SuperMethodInvocation extends MethodInvocation {

	private String identifier ;

	SuperMethodInvocation(String identifier_, Vector arguments_) {
		super(arguments_) ;
		identifier = identifier_ ;
	}

	protected String firstPart() {
		return "super."+identifier ;
	}

	Expr typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		super.typeCheck(env, currentModule, cu) ;
		Method m = currentModule.getSuperMostSpecificMethod(identifier, argumentTypes, currentModule) ;
		type = m.getReturnType() ;
		Modifiers mod = m.getDeclaration().getHeader().getModifiers() ;
		//System.out.println("currentModule="+currentModule+", m="+m+", mod="+mod) ;
		if (mod.isSet(Modifiers.INHERITED) && mod.isSet(Modifiers.ABSTRACT))
			throw new JamException("Cannot invoke method "+m+" using super because it is inherited abstract") ;
		return this ;
	}

}


