//
// Project : Jam
// File    : SynchronizedStatement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

class SynchronizedStatement extends Statement {

	private Expr expr ;
	private Block block ;

	SynchronizedStatement(Expr expr_, Block block_, Token sourcePosition_) {
		super(sourcePosition_) ;
		expr = expr_ ;
		block = block_ ;
	}

	public void dump(TabPrintStream s) throws JamException {
		s.println("synchronized ("+expr+") "+fileInfo(sourcePosition)) ;
		s.incLevel() ;
		block.dump(s) ;
		s.decLevel() ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		expr.resolveNames(cu) ;
		block.resolveNames(cu) ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		expr = expr.typeCheck(env, currentModule, cu) ;
		block.typeCheck(env, currentModule, cu) ;
	}

}
