//
// Project : Jam
// File    : ThrowStatement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

class ThrowStatement extends Statement {

	private Expr expr ;

	ThrowStatement(Expr expr_, Token sourcePosition_) {
		super(sourcePosition_) ;
		expr = expr_ ;
	}

	public void dump(TabPrintStream s) {
		s.println("throw "+expr+" ;"+fileInfo(sourcePosition)) ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		expr.resolveNames(cu) ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		expr = expr.typeCheck(env, currentModule, cu) ;
	}

}
