//
// Project : Jam
// File    : VariableDeclarator.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class VariableDeclarator {

	private VariableDeclaratorId decl ;
	private Expr initializer ; // may be null

	VariableDeclarator(VariableDeclaratorId decl_, Expr initializer_) {
		decl = decl_ ;
		initializer = initializer_ ;
	}

	VariableDeclaratorId getDeclaratorId() {
		return decl ;
	}

	void dump(TabPrintStream s) {
		decl.dump(s) ;
		if (initializer!=null) s.print(" = "+initializer) ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {
		if (initializer!=null)
			initializer.resolveNames(cu) ;
	}

	void typeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		if (initializer!=null)
			initializer = initializer.typeCheck(env, currentModule, cu) ;
	}

}
