//
// Project : Jam
// File    : VoidType.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

class VoidType extends Type { // should void be considered subtype of void ???
	
	private VoidType() {
		try	{
			Type.newType("void", this) ;
		} catch (JamException je) {
			throw new RuntimeException("Internal compiler error in VoidType()") ;
		}
	}

	protected boolean doubleDispatch(Type that) {
		return that.isSubtypeOf(this) ;
	}

	final static VoidType instance = new VoidType() ;

	public String toString() { return "void" ; }

	Type addDimensions(int dimensions) {
		return this ;
	}

	void resolveNames(CompilationUnit cu) throws JamException {}

}
