//
// Project : Jam
// File    : WhileStatement.java
// Author  : Giovanni Lagorio (gio@libertyline.com)
//

package jam ;

import invisible.jacc.parse.Token ;

class WhileStatement extends Statement {

	private Expr guard ;
	private Statement statement ;

	WhileStatement(Expr guard_, Statement statement_, Token sourcePosition_) {
		super(sourcePosition_) ;
		guard = guard_ ;
		statement = statement_ ;
	}

	void implResolveNames(CompilationUnit cu) throws JamException {
		guard.resolveNames(cu) ;
		statement.resolveNames(cu) ;
	}

	void dump(TabPrintStream s) throws JamException {
		s.println("while ("+guard+") "+fileInfo(sourcePosition)) ;
		s.incLevel() ;
		statement.dump(s) ;
		s.decLevel() ;
	}

	void implTypeCheck(Env env, ModuleType currentModule, CompilationUnit cu) throws JamException {
		guard = guard.typeCheck(env, currentModule, cu) ;
		statement.typeCheck(env, currentModule, cu) ;
	}

}
